Imports System.Text

Public Class IniFile

#Region ""

  '    
  Const KEY_BUFFER_SIZE% = 2047
  '    
  Const SECTION_BUFFER_SIZE% = 16384

#End Region

#Region ""


  Dim _fileName$


#End Region

#Region ""


  Public ReadOnly Property FileName$()
    Get
      Return Me._fileName
    End Get
  End Property

#End Region

#Region " "

  Public Sub New(ByVal FileName$)
    Me._fileName = Application.StartupPath + "\" + FileName
  End Sub

  '   
  Public Function ReadSections() As String()
    Return ReadSection(Nothing)
    '     vbNullChar 
    Dim strSections$ = Me.InternalReadString(Nothing, Nothing, "", EIniAtoms.Section)
    If strSections = "" Then Return New String(-1) {}
    '   (   Chr(0))
    Return strSections.ToString.Split(vbNullChar)
  End Function

  '    
  Public Function ReadSection(ByVal Section$) As String()
    '     vbNullChar 
    Dim strKeys$ = InternalReadString(Section, Nothing, "", EIniAtoms.Section)
    If strKeys = "" Then Return New String(-1) {}
    '   (   Chr(0))
    Return strKeys.ToString.Split(vbNullChar)

  End Function

  '         =
  Public Function ReadSectionValues(ByVal Section$) As Hashtable
    Dim KeyValueHash As New Hashtable
    '   
    Dim keys$() = ReadSection(Section)
    ' -  =
    For Each key As String In keys
      '  
      KeyValueHash(key) = Me.InternalReadString(Section, key, "", EIniAtoms.Key)
    Next
    Return KeyValueHash
  End Function


  '    
  Public Function ReadString$(ByVal Section$, ByVal Key$)
    Return ReadString(Section, Key, "")
  End Function

  '    
  Public Function ReadString$(ByVal Section$, ByVal Key$, ByVal [Default] As String)
    Return InternalReadString(Section, Key, [Default], EIniAtoms.Key)
  End Function

  '    
  Public Function ReadInt32%(ByVal Section$, ByVal Key$)
    Return Convert.ToInt32(ReadString(Section, Key))
  End Function

  '    
  Public Function ReadInt64(ByVal Section$, ByVal Key$) As Int64
    Return Convert.ToInt64(ReadString(Section, Key))
  End Function

  '    
  Public Function ReadDouble(ByVal Section$, ByVal Key$) As Double
    Return Convert.ToDouble(ReadString(Section, Key))
  End Function

  '    
  Public Function ReadByte(ByVal Section$, ByVal Key$) As Byte
    Return Convert.ToByte(ReadString(Section, Key))
  End Function

  '    
  Public Function ReadDate(ByVal Section$, ByVal Key$) As Date
    Return Convert.ToDateTime(ReadString(Section, Key))
  End Function

  '    
  Public Function ReadBool(ByVal Section$, ByVal Key$) As Boolean
    Return Convert.ToBoolean(ReadString(Section, Key))
  End Function



  '      ReturnedValue
  ' true,   - 
  Public Function ReadString(ByVal Section$, ByVal Key$, ByVal [Default] As String, ByRef ReturnedValue$) As Boolean
    Return InternalReadString(Section, Key, [Default], ReturnedValue, EIniAtoms.Key)
  End Function

  '    
	Public Sub Write(ByVal Section$, ByVal Key$, ByVal Value$)
		If WritePrivateProfileString(Section, Key, Value, Me._fileName) = 0 Then
			GenerateError()
		End If
	End Sub

	'    
	Public Sub Write(ByVal Section$, ByVal Key$, ByVal Value As Int32)
		Write(Section, Key, Convert.ToString(Value))
	End Sub

	'    
	Public Sub Write(ByVal Section$, ByVal Key$, ByVal Value As Int64)
		Write(Section, Key, Convert.ToString(Value))
	End Sub

	'    
	Public Sub Write(ByVal Section$, ByVal Key$, ByVal Value As Double)
		Write(Section, Key, Convert.ToString(Value))
	End Sub

	'    
	Public Sub Write(ByVal Section$, ByVal Key$, ByVal Value As Byte)
		Write(Section, Key, Convert.ToString(Value))
	End Sub
	'    
	Public Sub Write(ByVal Section$, ByVal Key$, ByVal Value As Char)
		Write(Section, Key, Convert.ToString(Value))
	End Sub
	'    
	Public Sub Write(ByVal Section$, ByVal Key$, ByVal Value As Boolean)
		Write(Section, Key, Convert.ToString(Value))
	End Sub

	'    
	Public Sub Write(ByVal Section$, ByVal Key$, ByVal Value As Date)
		Write(Section, Key, Convert.ToString(Value))
	End Sub




	'    
	Public Sub Write(ByVal Section$, ByVal Key$, ByVal Value As Object)
		Write(Section, Key, Convert.ToString(Value))
	End Sub







	'  ,     =  -
	Public Sub Write(ByVal Section$, ByVal Values As Hashtable)
		For Each de As DictionaryEntry In Values
			Write(Section, de.Key, de.Value)
		Next
	End Sub

	' 
	Public Sub EraseSection(ByVal Section$)
		If WritePrivateProfileString(Section, Nothing, Nothing, Me._fileName) = 0 Then
			GenerateError()
		End If
	End Sub

	' 
	Public Sub DeleteKey(ByVal Section$, ByVal Key$)
		If WritePrivateProfileString(Section, Key, Nothing, Me._fileName) = 0 Then
			GenerateError()
		End If
	End Sub

#End Region

#Region " "

  Private Enum EIniAtoms
    Key
    Section
  End Enum

  Private Function InternalReadString(ByVal Section$, ByVal Key$, ByVal [Default] As String, ByRef ReturnedValue$, ByVal IniAtom As EIniAtoms) As Boolean
    ReturnedValue = New String(vbNullChar, SECTION_BUFFER_SIZE)
    Dim readed As Int32 = GetPrivateProfileString(Section, Key, [Default], ReturnedValue, GetBufferSize(IniAtom), Me._fileName)
    If readed > 0 Then
      If ReturnedValue.Chars(readed - 1) = Nothing Then
        ReturnedValue = ReturnedValue.Substring(0, readed - 1)
      Else
        ReturnedValue = ReturnedValue.Substring(0, readed)
      End If
      Return True
    Else
      Return False
    End If
  End Function

  Private Function InternalReadString$(ByVal Section$, ByVal Key$, ByVal [Default] As String, ByVal IniAtom As EIniAtoms)
    Dim ret$
    If InternalReadString(Section, Key, [Default], ret, IniAtom) Then
      Return ret
    Else
      Return ""
    End If
  End Function

  Private Function GetBufferSize%(ByVal IniAtom As EIniAtoms)
    Select Case IniAtom
      Case EIniAtoms.Key
        Return Me.KEY_BUFFER_SIZE
      Case EIniAtoms.Section
        Return Me.SECTION_BUFFER_SIZE
    End Select
  End Function

  Private Sub GenerateError()
    Throw New Exception(String.Format( _
        "  !    [{0}]", Me.GetLastError))
  End Sub

#Region "Win API"


  Private Declare Auto Function GetPrivateProfileSection Lib "kernel32.dll" ( _
     ByVal lpAppName As String, _
     ByVal lpReturnedString As String, _
     ByVal nSize As Int32, _
     ByVal lpFileName As String) As Int32

  Private Declare Auto Function GetPrivateProfileSectionNames Lib "kernel32.dll" ( _
       ByVal lpszReturnBuffer As String, _
       ByVal nSize As Int32, _
       ByVal lpFileName As String) As Int32

  Private Declare Auto Function GetPrivateProfileString Lib "kernel32.dll" ( _
 ByVal lpApplicationName As String, _
 ByVal lpKeyName As String, _
 ByVal lpDefault As String, _
 ByVal lpReturnedString As String, _
 ByVal nSize As Int32, _
 ByVal lpFileName As String) As Int32

  Private Declare Auto Function GetPrivateProfileString Lib "kernel32.dll" ( _
ByVal lpApplicationName As String, _
ByVal lpKeyName As String, _
ByVal lpDefault As String, _
ByVal lpReturnedString As IntPtr, _
ByVal nSize As Int32, _
ByVal lpFileName As String) As Int32

  Private Declare Auto Function GetPrivateProfileString Lib "kernel32.dll" ( _
ByVal lpApplicationName As String, _
ByVal lpKeyName As String, _
ByVal lpDefault As String, _
ByVal lpReturnedString As StringBuilder, _
ByVal nSize As Int32, _
ByVal lpFileName As String) As Int32



  Private Declare Auto Function GetPrivateProfileStruct Lib "kernel32.dll" ( _
  ByVal lpszSection As String, _
  ByVal lpszKey As String, _
  ByVal lpStruct As Int32, _
  ByVal uSizeStruct As Int32, _
  ByVal szFile As String) As Int32

  Declare Auto Function WritePrivateProfileSection Lib "kernel32.dll" ( _
 ByVal lpAppName As String, _
 ByVal lpString As String, _
 ByVal lpFileName As String) As Int32

  Private Declare Auto Function WritePrivateProfileString Lib "kernel32.dll" ( _
   ByVal lpApplicationName As String, _
   ByVal lpKeyName As String, _
   ByVal lpString As String, _
   ByVal lpFileName As String) As Int32

  Private Declare Auto Function WritePrivateProfileStruct Lib "kernel32.dll" ( _
  ByVal lpszSection As String, _
  ByVal lpszKey As String, _
  ByVal lpStruct As Int32, _
  ByVal uSizeStruct As Int32, _
  ByVal szFile As String) As Int32

  Private Declare Auto Function GetLastError Lib "kernel32" () As Int32
  Private Declare Auto Sub SetLastError Lib "kernel32" (ByVal err As Int32)



#End Region

#End Region


End Class
